.module <files>
.module <time>

dirname(fname)
{
	def idx = rindex($fname /);
	if $idx
		return(substr($fname 0 add(1 $idx)))
	endif
}

basename(fname suffix='' sep='/')
{
	def idx = rindex($fname $sep);
	set idx = cond($idx add($idx 1) 0)
	set fname = substr($fname $idx)
	if issuffix($fname $suffix)
		set fname = substr($fname 0 sub(length($fname) length($suffix)))
	endif
	return($fname)
}

dosbasename(fname suffix='')
{
	set fname = basename($fname $suffix '\\')
	if index($fname ':')
		set fname = split($fname ':' '' '')
	endif
	return($fname)
}

dotlock(fname)
{
	def dir = dirname($fname);
	def tmp = tmpfile($(dir)\.pid());
	def strm = defstream(* $tmp basic true);
	writeto $strm pid();
	release stream $strm
	link $tmp $fname\.lock
	if ioerror() clearerr() rmfile($tmp) return endif
	rmfile($tmp)
	return(true)
}

dotlock-wait(fname delay=10 retry=10000)
{
	while(not(dotlock($fname)))
		sleep $delay
		decr retry 1
		if eq(int 0 $retry) return endif
	loop
	return(true)
}
