.pool default
main
{
	table identity get(ARGV 1)
	if not(check(identity lastlen))
		insert identity lastlen 0
	endif
	defstream instream get(ARGV 2) html;
	instream instream
	ioctl instream keepspaces;
	shared diversion;
	global basedir destination;
}

tag "BASE"
{
	if tag(DIR)
		set basedir = tag(DIR)
		if not(issuffix($basedir /))
			set basedir = $basedir/
		endif
	endif
}

tag "IDENTITY"
{
	if tag(ID)
		safe-insert(identity id tag(ID))
	endif
	if tag(PASSCODE)
		safe-insert(identity passcode tag(PASSCODE))
	endif
	if tag(EMAIL)
		safe-insert(identity email tag(EMAIL))
	endif
	if tag(MBOX)
		safe-insert(identity mbox $(basedir)tag(mbox))
	endif
}

tag "OTHER"
{
	safe-insert(identity tag(VAR) tag(VALUE))
}

tag "MIME"
{
	safe-insert(identity tag(TYPE) $(basedir)tag(DIR))
}

tag "NEWS"
{
	if tag(DIR)
		safe-insert(identity news $(basedir)tag(DIR))
	endif
	if tag(HOT)
		safe-insert(identity hotnews tag(HOT))
	endif
	if tag(CHARSET)
		safe-insert(identity newscharset tag(CHARSET))
	endif
	if tag(EXT)
		safe-insert(identity newsext tag(EXT))
	endif
	if tag(MAX)
		safe-insert(identity newsmax tag(MAX))
	endif
	if tag(MODE)
		safe-insert(identity newsmode tag(MODE))
	endif
	if tag(BLOCK)
		set destination = tag(BLOCK)
		prefix 'news:'
		clear diversion
		defstream diversion 'inline://default/diversion' html true;
	endif
}

tag "news:/NEWS"
{
	rmstream diversion
	safe-insert(identity news$destination $diversion)
	prefix ''
}

tag "news:*" { writetagto diversion }
char "news:?" { writetagto diversion }

tag "!--" { }

tag "*"
{
	echo "Unknown tag: $[]"
}

safe-insert(sto key val)
{
	if(check($sto $key))
		put $sto $key $val
	else
		insert $sto $key $val
	endif
}
