#!./sl
main
{
#	setenv "SL_TABLE_PATH"  "./tables"
	global tname = get-fname(1 "Table:");
	table tbl !$tname
	global key;
	global val;
	if not(instream())
		def s = get-fname(2 "Input file:");
		if not($s) 
			fill-from-console()
			exit
		endif
		defstream mystream $s basic;
		instream mystream
	endif
	prefix("key:")
}

get-fname
{
	if check(ARGV $1) return(get(ARGV $1)) endif
	return(trim(readline($2)))
}

put-into-table
{
	if check(tbl $1)
		echo "Duplicate key \'$1\', ignored"
		return
	endif
	insert tbl $1 $2
}

fill-from-console
{
	def inbuf;
	def ifs = readline('Field separator:');
	if not($ifs) set ifs = ' ' endif
	while set(inbuf readline(?))
		set val = split($inbuf $ifs '' key);
		put-into-table($key $val)
	loop
}

char "key:\t" { prefix "value:" }

char "key:\n"
{
	if not($key) return endif
	put-into-table($key "")
	set key = ""
}

char "key:*" { set key = $(key)$[value] }

char "value:\n" { put-into-table($key $val); prefix "key:"  
					set key = ""
					set val = ""
				}

char "value:*" { set val = $(val)$[value] }

