#! /usr/local/bin/sl

main
{
	global :restart :next :current :state :filename :capture :supress :translator :threshold
		   __logging;
	load(get(ARGV 1).tm.sc)
	init()
	def i tmp tmp1 out_pref = out.;
	if not($out_pref) set out_pref = out. endif
	set i = 2
	while;
		set tmp = get(ARGV $i)
		if not($tmp) error 'No input files given' endif
		if not(index($tmp =)) break endif
		set tmp1 = split($tmp '=' '' tmp)
		if eq($tmp OUTPREF)
			set out_pref = $tmp1
		elsif eq($tmp LOGFILE)
			defstream logfile file://$tmp1 basic true
			set __logging = true
		else
			global query.$tmp = $tmp1;
		endif
		incr i 1
	loop;
	foreach i sequence("\[$i\-sub(count(ARGV) 1)]")
		set :filename = get(ARGV $i)
		if not($:filename)
			error 'Standard input cannot be used'
		endif
		defstream input $:filename html;
		ioctl(input keepspaces)
		instream input
		defstream output $out_pref$:filename html true;
		outstream output
		if isproc(user-atbof) user-atbof() endif
		while;
			set :current = getpos(input)
			read
			set :next = getpos(input)
			if iseof() break endif
			if not($[])
				if $:capture
					set $:capture = var($:capture)$[value]
				elsif not($:supress)
					write translate($:translator $[value])
				endif
			else
				clear :threshold
				if do-handler() break endif
			endif
		loop;
		if and(iseof() isproc(user-ateof)) user-ateof() endif
		rmstream input
		rmstream output
	loop;
}

message(text)
{
	if $__logging
		writeto logfile $text\n
	else
		echo $text
	endif
}

do-handler()
{
	def tmp newstate oldstate;
	clear :restart
	clear :threshold
	while;
		if $newstate
			set oldstate = $:state
			set :state   = cond(neq($newstate :) $newstate)
		endif
		set tmp = handler($:restart)
		if $newstate
			set :state = $oldstate
		endif
		if eq($tmp nextfile) return(true) endif
		if isprefix($tmp restart)
			split($tmp ' ' '' '' :restart newstate :threshold)
		else
			break
		endif
	loop
}
